precision highp int;
precision highp float;
 #include <OgreUnifiedShader.h>
varying vec2 vUv;
mat3 mat4ToMat3(mat4 m) { return mat3(m[0].xyz, m[1].xyz, m[2].xyz); }
 const int kSC_SymbolCullingDistanceFactor = 4;
 const int kSC_OSMTileCullingDistanceFactor = 4;
 const int kSC_UseOSMDataFromAncestorDiff = 1;
 const int kSC_MaxOSMLevelFromServer = 15;
  const float kSC_Skybox_MinVisibleDistance = 500000.0;
  const float kSC_Skybox_Height = 1000000.0;
  const float kSC_UserMarker_OuterCircleRadius = 12.0;
 const int kSC_MaxBoundingBoxesPerTopoLayer = 16;
 const float kSC_CameraFOV = 42.0;
 const float kSC_ElevationExaggerationMinHeightRange = 200.0;
 const float kSC_ElevationExaggerationMinHeightRangeFactor = 1.9;
 const float kSC_ElevationExaggerationMaxHeightRange = 2000.0;
 const float kSC_ElevationExaggerationMaxHeightRangeFactor = 1.15;
 const float kSC_FlatModeExaggeration = 0.1;
uniform float mercatorScale;
uniform float elevationExaggerationFactor;
vec4 upScalePoint(vec4 point, mat4 modelMatrix)
{
    vec4 scaledPoint = point;
    float offsetZ = modelMatrix[3][2];
    scaledPoint.z =
        (scaledPoint.z + offsetZ) * mercatorScale * elevationExaggerationFactor - offsetZ;
    return scaledPoint;
}
vec4 upScalePoint(vec4 vec)
{
    vec4 scaledVec = vec;
    scaledVec.z *= mercatorScale * elevationExaggerationFactor;
    return scaledVec;
}
vec3 _applyScaleOnNormal(vec3 vec, float scale)
{
    vec3 scaledVec = vec;
    scaledVec.xy *= scale;
    return normalize(scaledVec);
}
vec3 applyElevationScaleOnNormal(vec3 vec)
{
    return _applyScaleOnNormal(vec, mercatorScale * elevationExaggerationFactor);
}
vec3 applyMercatorScaleOnNormal(vec3 vec) { return _applyScaleOnNormal(vec, mercatorScale); }
    uniform vec2 pixelSize;
uniform float fontSizeCur;
uniform float fontSizeMax;
uniform float offsetX;
uniform float offsetY;
uniform float pixelRatio;
uniform mat4 modelMatrix;
uniform mat4 modelViewMatrix;
uniform mat4 projectionMatrix;
attribute vec4 position;
attribute vec3 normal;
attribute vec2 uv0;
void main()
{
    vUv = uv0;
    float q = fontSizeCur / fontSizeMax;
    vec2 offset = vec2(offsetX, offsetY) * fontSizeMax;
    vec4 scaledPosition = upScalePoint(position, modelMatrix);
    vec4 sPosition = projectionMatrix * modelViewMatrix * scaledPosition;
    vec2 screenToView = 2.0 * pixelSize;
    float aspect = projectionMatrix[1][1] / projectionMatrix[0][0];
    vec2 totalOffset = (normal.xy + offset) * q;
    totalOffset.y = -totalOffset.y;
    sPosition.xy += totalOffset * screenToView * sPosition.w;
    gl_Position = sPosition;
}
