precision highp int;
precision highp float;
 #include <OgreUnifiedShader.h>
    attribute vec4 position;
attribute vec3 normal;
attribute vec2 uv0;
uniform float mercatorScale;
uniform float elevationExaggerationFactor;
uniform mat4 modelMatrix;
uniform mat4 modelViewMatrix;
uniform mat4 projectionMatrix;
uniform vec3 cameraPosition;
uniform vec4 _TopoTransform;
varying vec2 vUv;
vec4 upScalePoint(vec4 vec)
{
    vec4 scaledVec = vec;
    scaledVec.z *= mercatorScale * elevationExaggerationFactor;
    return scaledVec;
}
vec2 CalculateUV(vec4 ipos, vec4 texTransform)
{
    return (ipos.xy - texTransform.xy) / texTransform.zw;
}
vec4 calc_vertex_pos()
{
    vec3 outPos = position.xyz;
    vUv = CalculateUV(vec4(outPos, 1.0), _TopoTransform);
    vec4 scaledPosition = upScalePoint(position);
    vec4 _position = projectionMatrix * modelViewMatrix * scaledPosition;
    return _position;
}
void main() { gl_Position = calc_vertex_pos(); }
